Attribute VB_Name = "NameExtr"
Attribute VB_Description = "Path\\filename.ext functions."
'=================================================
'misc Path\filename.ext functions.
'Thomas J. Esh <76467.1255@compuserve.com>
'=================================================

Option Explicit

#If Win32 Then
    Private Const MAX_PATH = 260
    Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
#End If

Public Function PathExists(sPath As String) As Boolean
Attribute PathExists.VB_Description = "Returns true if Path (folder) exists."
    'Returns true if Path (folder) exists.
    On Error GoTo ErrPE1
    If (GetAttr(sPath) And vbDirectory) Then PathExists = True
ErrPE1:
End Function

Private Function RightMost(sInp As String, sFind As String) As Integer
Attribute RightMost.VB_Description = "Returns position of rightmost occurance sFind in sInp, 0 if none"
    'Returns position of rightmost occurance sFind in sInp, 0 if none
    Dim P1 As Integer, P2 As Integer
    
    If sFind = "" Then Exit Function
    P2 = 0
    Do
        P1 = P2
        P2 = InStr(P1 + 1, sInp, sFind)
    Loop While P2 > 0
    RightMost = P1
End Function

Public Function NameOnly(InputString As String) As String
Attribute NameOnly.VB_Description = "Returns filename.ext portion of full path."
    'Returns filename.ext portion of full path.
    Dim iLastToken As Integer
    
    If InputString = "" Then Exit Function
    NameOnly = InputString
    iLastToken = RightMost(InputString, "\")
    If iLastToken = 0 Then Exit Function
    NameOnly = Right(InputString, (Len(InputString) - iLastToken))
End Function

Public Function ExtOnly(InputString As String, Optional bInclSep) As String
Attribute ExtOnly.VB_Description = "Returns file extension portion of (path\\)filename. Optional argument bInclSep=True (default) to include ""."" prefix."
    'return Extension portion of file name
    'return "" if none
    'include "." if bInclSep=true (default)
    Dim sName As String
    Dim iLastSep As Integer
    
    sName = NameOnly(InputString)
    If sName = "" Then Exit Function
    
    iLastSep = RightMost(sName, ".")
    If iLastSep = 0 Then Exit Function
    ExtOnly = Right(sName, Len(sName) - iLastSep + 1)
    If Not IsMissing(bInclSep) Then
        If CBool(bInclSep) = False Then ExtOnly = Right(sName, Len(sName) - iLastSep)
    End If
End Function

Public Function PathOnly(InputString As String) As String
Attribute PathOnly.VB_Description = "Returns path portion of full path+filename including ""\\"""
    'return Path portion of of path+filename
    'return "" if input="" or if no "\"
    'includes final "\"

    PathOnly = Left(InputString, (Len(InputString) - Len(NameOnly(InputString))))
End Function

Public Function ShortNameOnly(InputString As String) As String
Attribute ShortNameOnly.VB_Description = "Returns filename without extension."
    'return filename WITHOUT extension
    Dim sName As String
    
    sName = NameOnly(InputString)
    ShortNameOnly = Left(sName, (Len(sName) - Len(ExtOnly(sName, True))))
End Function

Public Function GetDOSpath(sLongName As String) As String
Attribute GetDOSpath.VB_Description = "Returns DOS version of path/filename (8.3)  Win32 only.\r\nInput echoed if Win16"
    'return DOS path & filename (8.3 compliant)
    #If Win32 Then
        Dim sDosName As String, lRet As Long
        
        sDosName = String(MAX_PATH + 1, 0)
        lRet = GetShortPathName(sLongName, sDosName, MAX_PATH)
        If lRet > 0& Then GetDOSpath = Left(sDosName, lRet)
    #Else 'stub it...
        GetDOSpath = sLongName
    #End If
End Function
